$INTERFACE UUDBP1                                             97/12/01
$REM LU
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON6='1.0$P-4'
  $GAML='1.0$P 0'
  $GAMU='6.0$P 0'
  $MET=1
  $HELP
    SELECTION OF SELF SCALING:
      ABS(MET1)=1 - SELF SCALING SUPPRESSED
      ABS(MET1)=2 - INITIAL SELF SCALING
      ABS(MET1)=3 - CONTROLLED SELF SCALING
      ABS(MET1)=4 - SIMPLIFIED CONTROLLED SELF SCALING
      ABS(MET1)=5 - SELF SCALING IN EACH ITERATION
           MET1>0 - BASIC INITIAL SELF SCALING
           MET1<0 - MODIFIED INITIAL SELF SCALING
  $CHECK(MET1,3,'\-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $IF(NET1=-3) $NET1=3
  $IF(NET1=-4) $NET1=4
  $IF(NET1=-5) $NET1=5
  $IF(NET1= 3) $GAML='0.6$P 0'
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      MET2=1 - QUADRATIC MODEL
      MET2=2 - BACKWARD TAYLOR EXPANSION (3 TERMS)
      MET2=3 - BACKWARD TAYLOR EXPANSION (4 TERMS)
      MET2=4 - HOMOGENEOUS MODEL
  $CHECK(MET2,4,'\1\2\3\4',4)
  $NET2=MET2
  $MET3=1
  $MET4=1
  $MET5=0
  $SNORM=0
  $ADD(REAL,'\$CZ($NF*$NF)\$S($NF)\$XO($NF)\$GO($NF)')
  $POM4='(NF,N,$CZ,$S,$XO,$GO,R,PO'
  $POM6='(NF,N,CZ,S,XO,GO,R,PO'
  $IF(NET1=3)
    $ADD(POM4,',PAR1,PAR2')
    $ADD(POM6,',PAR1,PAR2')
  $ENDIF
  $IF(NET2>1)
    $ADD(POM4,',F,FO,P')
    $ADD(POM6,',F,FO,P')
  $ENDIF
  $IF(MOS5=0)
    $ADD(REAL,'\GAM')
    $ADD(POM4,',ETA9,GAM)')
    $ADD(POM6,',ETA9,GAM)')
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDBP1$(NUMSUB)$POM4
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDBP1
*     ----------------------------------------
  SUBROUTINE UUDBP1$(NUMSUB)$POM6
  $$INCLUDE('UMCOMM')
  INTEGER NF,N
  $$FLOAT CZ(NF*NF),S(NF),XO(NF),GO(NF),R,PO,ETA9
  $$IF($NET1=3) $$FLOAT PAR1,PAR2
  $$IF($NET2>1) $$FLOAT F,FO,P
  $$FLOAT AA,CC
  $$FLOAT UXVDOT
  $$FLOAT DIS,ETA,A,B,C,GAM,RHO,PAR
  INTEGER IUPDT
  LOGICAL L1,L3
  $$IF ($NET1=3) LOGICAL L2
  $$IF($NET2>1) $$FLOAT POM1,POM2
  CALL UOU1D1(N,$XO,$GO)
  IF (IDECF.NE.9) THEN
  ITERH=-1
  TUXX='BAD DEC9'
  CALL UOERR1('UUDBP1',1)
  GO TO 22
  ENDIF
  L1=ABS($MET1).GE.3.OR.ABS($MET1).EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*     DETERMINATION OF THE PARAMETERS A, B, C
*
  B=UXVDOT(N,XO,GO)
  IF (B.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG.'
  GO TO 22
  ENDIF
  A=UXVDOT(N,GO,GO)
  IF (A.LE.ZERO) THEN
  ITERH=1
  TUXX='A - NEG.'
  GO TO 22
  ENDIF
  C=UXVDOT(N,XO,XO)
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='A - NEG.'
  GO TO 22
  ENDIF
*
*     DETERMINATION OF THE PARAMETER RHO (NONQUADRATIC PROPERTIES)
*
  $$IF($NET2=1)
    RHO=ONE
  $$ELSE
    IF (PO.EQ.ZERO) THEN
    RHO=ONE
    ELSE
    POM1=(F-FO)/PO
    POM2=P/PO
    $$IF($NET2=2)
      IF (POM1.EQ.POM2.OR.POM2.EQ.ONE) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(POM2-POM1)
      ENDIF
    $$ELSEIF($NET2=3)
      IF (TWO*(POM2-ONE)-THREE*(POM1-ONE).EQ.ZERO) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(TWO*(POM2-ONE)-THREE*(POM1-ONE))
      ENDIF
    $$ELSEIF($NET2=4)
      IF (POM1.EQ.ONE.OR.POM2.EQ.POM1) THEN
      RHO=ONE
      ELSE
      RHO=(POM1-ONE)/(POM2-POM1)
      ENDIF
    $$ENDIF
    IF(RHO.LE.$CON4) RHO=ONE
    IF(RHO*$CON4.GE.ONE) RHO=ONE
    ENDIF
  $$ENDIF
  AA=A/B
  CC=C/B
  IUPDT=0
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  PAR=A/B
  GAM=RHO/PAR
  $$IF($MET1<0)
    IF (NIT.EQ.KIT) THEN
    GAM=MAX(GAM,$CON6)
    GAM=MIN(GAM,ONE/$CON6)
    PAR=RHO/GAM
    ENDIF
  $$ENDIF
  $$IF($NET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.$GAML
    L3=L3.OR.GAM.GT.$GAMU
    ENDIF
  $$ELSEIF($NET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.$GAML.OR.GAM.GT.$GAMU
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) THEN
  GAM=ONE
  PAR=RHO/GAM
  ENDIF
  NUPD=NUPD+1
*
*     BFGS UPDATE
*
  ETA=ONE
  CALL UXVDIR(N,SQRT(PAR/CC),$XO,$GO,$GO)
  CALL UXDCMU(NF,N,$CZ,-ONE/B,$S,$GO)
  ITERH=0
  IF (GAM.EQ.ONE) GO TO 22
*
*     SCALING
*
  CALL UXVSCL(NF*N,SQRT(GAM),$CZ,$CZ)
  NSCL=NSCL+1
22 CONTINUE
  CALL UOU1D2(N,$CZ,$S,RHO,GAM,PAR,A,B,C,ETA,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDBP1'
  $ENDADD
  $EXIT
