$INTERFACE UUDGA3                                             17/12/01
$REM LU
  $POMD='D'
  $POMH=H
  $POMN='N'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $ADD(REAL,'\$AG($NF*$NA)\$AGO($NF*$NA)\$AF($NA)\$G($NF)\$S($NF)&
  \$XO($NF)\$GO($NF)\$AFO($NA)\AFD($NA)')
  $POM1='$N,NA'
  $POM2='N,NA'
  $IF(DEC='A')
    $ADD(POM1,',$AG,$AF,$G,$XO,$GO,$AFO,$AFD')
    $ADD(POM2,',AG,AF,G,XO,GO,AFO,AFD')
  $ELSEIF(DEC='Q')
    $AFS='AFS'
    $ADD(REAL,'\$S($NF)')
    $IF(MOS2=1)
      $POMD='E'
    $ELSE
      $POMD='D'
    $ENDIF
    $IF(MOS3=1)
      $ADD(REAL,'\$XS($NF)\$AFS($NA)')
      $ADD(POM1,',$H,$AG,$AF,$G,$S,$XO,$GO,$XS,$AFO,$AFD,$AFS,ETA2')
      $ADD(POM2,',H,AG,AF,G,S,XO,GO,XS,AFO,AFD,AFS,ETA2')
    $ELSE
      $ADD(POM1,',$H,$AG,$AF,$G,$S,$XO,$GO,$AFO,$AFD,ETA2')
      $ADD(POM2,',H,AG,AF,G,S,XO,GO,AFO,AFD,ETA2')
    $ENDIF
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDG$(DEC)3$(NUMSUB)($POM1)
  $ADD(SUBROUTINES)
*     ----------------------------------
*     FACTORIZED VARIABLE METRIC UPDATES
*     TEMPLATE : UUDGA3
*     ----------------------------------
  SUBROUTINE UUDG$(DEC)3$(NUMSUB)($POM2)
  $$INCLUDE('UMCOMM')
  INTEGER N,NA
  $$FLOAT AG(N*NA),AF(NA),G(N),XO(N),GO(N),AFO(NA),AFD(NA)
  $$FLOAT UXVDOT
  $$FLOAT A,B,B1,B2,C,C1,C2,D,DEN,RHO,GAM
*  CALL UOU1D1(N,XO,GO)
  $$IF(DEC='A')
    $$I=0
    IF (IDECA.NE.0) THEN
  $$ELSEIF(DEC='Q')
    INTEGER INF
    $$FLOAT S(N),ETA2
    $$IF(MOS3=1)
      $$FLOAT H(N*NA),XS(N),AFS(NA)
    $$ELSE
      $$FLOAT H(N*(N+1)/2)
    $$ENDIF
    $$I=1
    IF (IDECA.EQ.0) THEN
*
*     QR DECOMPOSITION
*
    DEN=ETA2
    $$IF(MOS3=1)
      CALL UX$(POMD)$(JASA)QF(N,NA,AG,H,XS)
      CALL UX$(POMD)CRC(N,NA,AG,INF,DEN)
    $$ELSE
      CALL UXD$(JASA)PF(N,NA,AG,H)
      CALL UXDPRC(N,H,INF,DEN)
    $$ENDIF
    NDECA=NDECA+1
    IDECA=1
    ELSE IF (IDECA.NE.1) THEN
  $$ENDIF
  ITERH=-1
  TUXX='BAD DEC$$I'
  CALL UOERR1('UUDG$(DEC)3',1)
  GOTO 22
  ENDIF
*
*     NEW VARIABLE METRIC UPDATE
*
  GAM=ONE
  RHO=ONE
  $$IF(DEC='A')
    CALL UXD$(JASA)MM($POMA,AG,XO,AFO)
  $$ELSEIF(DEC='Q')
    CALL UXVCOP(N,XO,S)
    $$IF(MOS3=1)
      CALL UX$(POMD)CRM(N,NA,AG,S,1)
      CALL UXD$(JASA)MM($POMA,H,S,AFO)
      CALL UX$(POMD)CQM(N,NA,AG,AFO,XS)
    $$ELSE
      CALL UXDPRM(N,H,S,1)
      CALL UXD$(JASA)MM($POMA,AG,S,AFO)
    $$ENDIF
  $$ENDIF
  A=UXVDOT(NA,AF,AF)
  B=UXVDOT(NA,AF,AFO)
  C=UXVDOT(NA,AFO,AFO)
  B1=UXVDOT(N,XO,GO)*GAM/RHO
  B2=UXVDOT(N,XO,G)*SQRT(GAM)
  IF (B1.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG'
  GO TO 22
  ENDIF
  IF (A*B1-B2*B2.LT.ZERO.OR.A*C-B*B.LE.ZERO) THEN
  ITERH=3
  TUXX='R - NEG'
  GO TO 22
  ENDIF
  C2=SQRT((A*B1-B2*B2)/(A*C-B*B))
  C1=(B2-C2*B)/A
  CALL UXVLIN(NA,C1,AF,C2,AFO,AFD)
  D=UXVDOT(NA,AFO,AFD)
  $IF(DEC='A')
    CALL UXD$(JASB)MD($POMA,AG,AF,-SQRT(GAM),G,XO)
    CALL UXD$(JASB)MD($POMA,AG,AFD,-GAM/RHO,GO,GO)
  $$ELSEIF(DEC='Q')
    $$IF(MOS3=1)
      CALL UXVCOP(NA,AF,AFS)
      CALL UX$(POMD)CQB(N,NA,AG,AFS,XS)
      CALL UXD$(JASB)MM($POMA,H,AFS,XO)
      CALL UX$(POMD)CRM(N,NA,AG,XO,-1)
      CALL UXVCOP(NA,AFD,AFS)
      CALL UX$(POMD)CQB(N,NA,AG,AFS,XS)
      CALL UXD$(JASB)MM($POMA,H,AFS,S)
      CALL UX$(POMD)CRM(N,NA,AG,S,-1)
    $$ELSE
      CALL UXD$(JASB)MM($POMA,AG,AF,XO)
      CALL UXDPRM(N,H,XO,-1)
      CALL UXD$(JASB)MM($POMA,AG,AFD,S)
      CALL UXDPRM(N,H,S,-1)
    $$ENDIF
    CALL UXVDIR(N,-SQRT(GAM),G,XO,XO)
    CALL UXVDIR(N,-GAM/RHO,GO,S,GO)
  $$ENDIF
  DEN=B*B1-D*B2
  CALL UXVLIN(N,B1/DEN,XO,-B2/DEN,GO,XO)
  $$IF(DEC='A')
  CALL UXD$(JASA)MU($POMA,AG,-ONE,AFO,XO)
  CALL UXVDIR(N,-D,XO,GO,GO)
  CALL UXD$(JASA)MU($POMA,AG,-ONE/B1,AFD,GO)
  $$ELSEIF(DEC='Q')
    $$IF(MOS3=1)
      CALL UX$(POMD)$(JASA)QU(N,NA,H,AG,XS,-ONE,AFO,XO,S,INF)
      CALL UXVDIR(N,-D,XO,GO,GO)
      CALL UX$(POMD)$(JASA)QU(N,NA,H,AG,XS,-ONE/B1,AFD,GO,S,INF)
    $$ELSE
      CALL UXD$(JASA)PU(N,NA,AG,H,-ONE,AFO,XO,S,INF)
      CALL UXVDIR(N,-D,XO,GO,GO)
      CALL UXD$(JASA)PU(N,NA,AG,H,-ONE/B1,AFD,GO,S,INF)
    $$ENDIF
  $$ENDIF
  NUPD=NUPD+1
  ITERH=0
22 CONTINUE
*  CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDG$(DEC)2'
  $ENDADD
  $EXIT
